'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _encoder = require('./encoder');

var _encoder2 = _interopRequireDefault(_encoder);

var _decoder = require('./decoder');

var _decoder2 = _interopRequireDefault(_decoder);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var JWT = {
  encode: function encode(body, key) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var encoder = new _encoder2.default(body, key, options);

    return encoder.encodeAndSign();
  },

  decode: function decode(token, key) {
    var decoder = new _decoder2.default(key);

    return decoder.decodeAndVerify(token);
  }
};

exports.default = JWT;